<template>
  <div ref="el" style="direction: ltr;overflow: hidden">
    <div :style="{ width: `${width}px` }" style="direction: rtl">
      <slot />
    </div>
  </div>
</template>

<script>
import IScroll from '../../plugins/iscroll-probe'
let iScroll = null
export default {
  name: 'TouchScroll',
  props: {
    width: { type: Number, default: 0 },
    scrollStartTime: { type: Number, default: 1000 }
  },
  data() {
    return {
      iScroll: null
    }
  },
  mounted() {
    iScroll = new IScroll(this.$refs.el, {
      probeType: 3,
      click: true,
      scrollX: true,
      scrollY: false,
      disablePointer: true,
      disableTouch: false,
      disableMouse: false,
      preventDefault: true
    })
    window.addEventListener('resize', () => {
      iScroll.refresh()
    })
    this.iScroll = iScroll
    this.$nextTick(() => {
      iScroll.scrollTo(iScroll.maxScrollX, 0, this.scrollStartTime)
    })
  },
  beforeDestroy() {
    if (iScroll) iScroll.destroy()
  },
  updated() {
    if (iScroll) iScroll.refresh()
  }
}
</script>
